Migrate Center Agent
===
用于将用户的数据从外部IDC或者云服务器中迁移至百度云，本代码只包含了agent的实现，需要console配置实现完整的迁移中心功能

环境要求
---
当前迁移中心支持的迁移源端操作系统版本包括CentOS 6(i386|x86_64)/CentOS 7(i386|x86_64)/Ubuntu 14.04|16.04|18.04(i386|x86_64)/Debian 8.11|9.9，
请在使用之前确保 Python 版本大于等于 3.4，同时保证安装有对应的 pip，并且迁移源端安装有版本大于等于 3.1.0 的 rsync。

为了保证迁移后 BCC 云服务器的正常运行，建议用户在迁移之前于迁移源上安装 cloud-init，详见 https://cloud.baidu.com/doc/BCC/s/hjwvyngyc

安装
---
使用 tar xvf Baidu_Cloud_Migrate_Tool.tar进行解压缩，进入 agent 安装目录 cd migrate-center-agent/，使用 setup.sh 一键安装 agent 运行所需的对应依赖。
```shell script
sh setup.sh
```

运行
---
在运行之前，请在 user_cfg.json 里面填入迁移创建出的镜像所属用户的 aksk。需要有console和中转虚机配合运行，请在迁移过程中保持终端窗口打开状态，迁移完成后可以在 migrate-center.log 里面看到 agent 执行的日志输出。
```shell script
./migrate-center start
```

测试
---
- 测试agent_client能否正常的向console注册迁移源信息以及发送心跳包，单机测试需要本地起相应的http server。
```shell script
python3 test/test_agent_client.py
```

- 测试心跳相关类和方法, 单机测试需要本地起相应的http server。
```shell script
python3 test/test_heart_beat.py
```

- 测试挂载磁盘。需要搭建好迁移源和中转虚机的环境，迁移源要能够免密以root身份登录中转虚机。中转虚机需要有足够多的未挂载的数据盘以容纳
迁移源的系统盘和数据盘的文件。
```shell script
python3 test/test_mount.py
```

- 测试利用rysnc同步文件。迁移源要能够免密以root身份登录中转虚机。中转虚机需要有足够多的未挂载的数据盘以容纳
迁移源的系统盘和数据盘的文件。
```shell script
python3 test/test_rsync.py
```

- 测试同步引导扇区。需要迁移源要能够免密以root身份登录中转虚机。
```shell script
python3 test/test_boot.py
```

- 测试修改配置文件。需要迁移源要能够免密以root身份登录中转虚机。
```shell script
python3 test/test_modify.py
```

- 测试卸载文件系统和磁盘。需要迁移源要能够免密以root身份登录中转虚机。
```shell script
python3 test/test_umount.py
```

- 测试运行。本地测试需要在本地起相应的http server，并且搭建好迁移源和中转虚机的环境。
```shell script
python3 test/test_run.py
```
