################################################################################
#
# Copyright (c) 2020 Baidu.com, Inc. All Rights Reserved
#
################################################################################

"""
Provides access to the BCE credentials used for accessing BCE services: BCE access key ID and
secret access key.
These credentials are used to securely sign requests to BCE services.
"""
from baidubce import compat

class BceCredentials(object):
    """
    Provides access to the BCE credentials used for accessing BCE services:
    BCE access key ID and secret access key.
    """
    def __init__(self, access_key_id, secret_access_key):
        self.access_key_id = compat.convert_to_bytes(access_key_id)
        self.secret_access_key = compat.convert_to_bytes(secret_access_key)
