################################################################################
#
# Copyright (c) 2020 Baidu.com, Inc. All Rights Reserved
#
################################################################################

"""
This module represents the data sent when registering the migration source
"""
from baidubce import utils

class SourceConfig(object):
    """
    The config of the migration source
    """
    def __init__(self):
        self.cpu = utils.get_cpu()
        self.memory = utils.get_memory()
        self.system_disk_size, self.data_disks_size = utils.get_disk_size()

    def jsonable(self):
        """
        Return the json representation of the object
        """
        return self.__dict__


class MigrationRequest(object):
    """
    The information of the migration source
    """
    def __init__(self):
        self.ip = utils.get_ip_address()
        self.mac = utils.get_mac_address()
        self.source_config = SourceConfig()
        self.os_info = utils.get_os_info()
        self.ssh_pub_key = utils.get_ssh_pub_key()
        self.partition_info = utils.get_partition_info()

    def jsonable(self):
        """
        Return the json representation of the object
        """
        return self.__dict__


