#!/bin/bash

grep -i virtio /boot/config-$(uname -r) | grep -E "VIRTIO_BLK|VIRTIO_NET" 1>/dev/nul

if [ $? -ne 0 ]; then
    echo 1
else
    rsync --version | grep -E "3.1|3.2|3.3|3.4"
    if [ $? -ne 0 ]; then
        echo 3
    else
        val1=`grep -i virtio /boot/config-$(uname -r) | grep VIRTIO_NET`
        val2=`grep -i virtio /boot/config-$(uname -r) | grep VIRTIO_BLK`
        if [[ ${val1:0-1:1} == "y" ]] && [[ ${val2:0-1:1} == "y" ]]; then
            echo 0
        else
            sys_version=`cat /etc/issue`
            if [[ $sys_version =~ "Ubuntu" ]]; then
                lsinitramfs /boot/initrd.img-$(uname -r) | grep virtio
            fi
            if [[ $sys_version =~ "Debian" ]]; then
                lsinitramfs /boot/initrd.img-$(uname -r) | grep virtio
            fi
            if [[ $sys_version =~ "CentOS" ]]; then
                lsinitrd /boot/initramfs-$(uname -r).img | grep virtio
            fi
            if [ $? -ne 0 ]; then
                echo 2
            else
                echo 0
            fi
        fi
    fi
fi
