#!/bin/sh

# main
#parse arguments
set -m

boot_disk=$1
boot_partition=$2
disk_uuid=$3

#if [ -z "${disk_uuid}" ]; then
#    disk_uuid=$(blkid -s UUID ${boot_partition} | awk '{print $2}'| sed 's/UUID=//g' | tr -d '"')
#fi
# grub_file
grub_file=$(find /boot/grub* -name grub.cfg)
if [ -z "${grub_file}" ]; then
    grub_file=$(find /boot/grub* -name grub.conf)
    if [ -z "${grub_file}" ]; then
        echo "No grub file found. Please check ..."
        exit 1
    else
        grub_version="grub1"
    fi
else
    grub_version="grub2"
fi

# install grub
if [ "${grub_version}" = "grub1" ]; then
    grub --batch --no-floppy <<EOF
device (hd1) ${boot_disk}
root (hd1,0)
setup (hd1)
quit
EOF
else
    if type grub-install 2>/dev/null; then
        grub-install ${boot_disk}
    elif type grub2-install 2>/dev/null; then
        grub2-install ${boot_disk}
    else
        echo "No grub command found. Please check ..."
        exit 1
    fi
fi

# update grub file
if [ "${grub_version}" = "grub1" ]; then
    # update uuid for root
    sed -i "s/\(^[[:space:]]*kernel.*\) root=\S*\(.*\)/\1 root=UUID=${disk_uuid}\2/g" ${grub_file}
    # use /boot/vmlinuz|initramfs
    sed -i "s/kernel \/.*vmlinuz/kernel \/boot\/vmlinuz/g" ${grub_file}
    sed -i "s/initrd \/.*initramfs/initrd \/boot\/initramfs/g" ${grub_file}
else
    if type grub-mkconfig 2>/dev/null; then
        grub-mkconfig -o ${grub_file}
    elif type grub2-mkconfig 2>/dev/null; then
        grub2-mkconfig -o ${grub_file}
    else
        echo "No grub command grub-mkconfig found. Please check ..."
        exit 1
    fi

fi
echo "finish" >> grub_install.log
