################################################################################
#
# Copyright (c) 2020 Baidu.com, Inc. All Rights Reserved
#
################################################################################
"""
This module defines task status
"""

from enum import Enum

Ready = "ready"
Preparing = "preparing"
SyncStart = "sync_start"
SyncFinish = "sync_finish"
Stopped = "stopped"
Finished = "finished"
Error = "error"

Syncing = "syncing"

class Step(Enum):
    """
    Steps of the entire synchronization process
    """
    MOUNTING = "mounting"
    SYNCING = "syncing"
    BOOTING = "booting"
    MODIFYING = "modifying"
    UMOUNTING = "umounting"
