from migrate_center_agent import boot

import unittest

class TestBoot(unittest.TestCase):
    def setUp(self) -> None:
        dest_ip = "192.168.56.101"
        dest_test_user = "root"
        self.boot = boot.Boot(root_user=dest_test_user, ip=dest_ip)

    def test_mount_proc(self):
        err, err_log = self.boot.mount_proc()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_mount_bind(self):
        err, err_log = self.boot.mount_bind()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_mount_devpts(self):
        err, err_log = self.boot.mount_devpts()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_grub_command(self):
        grub_command = self.boot.grub_command()
        print(grub_command)

    def test_install_grub(self):
        err, err_log = self.boot.install_grub()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_boot(self):
        self.boot.boot()
        if self.boot.err:
            print(self.boot.err_log)
        self.assertFalse(self.boot.err)


if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestBoot("test_mount_proc"))
    suite.addTest(TestBoot("test_mount_bind"))
    suite.addTest(TestBoot("test_mount_devpts"))
    suite.addTest(TestBoot("test_grub_command"))
    suite.addTest(TestBoot("test_install_grub"))
    suite.addTest(TestBoot("test_boot"))
    runner = unittest.TextTestRunner()
    runner.run(suite)
