from migrate_center_agent import heart_beat
from baidubce import agent_client
from baidubce import heartbeat_request
from baidubce.auth.bce_credentials import BceCredentials
from baidubce.bce_client_configuration import BceClientConfiguration

import unittest

class TestHeartBeat(unittest.TestCase):
    def setUp(self) -> None:
        """
        Set up agent client
        """
        host = b"http://localhost:8080"
        ak = b"test"
        sk = b"test"
        config = BceClientConfiguration(credentials=BceCredentials(ak, sk),
                                        endpoint=host)
        self.client = agent_client.AgentClient(config)

    def test_heart_beat(self):
        """
        Test heart beat and its response
        """
        response = self.client.register_migration_source()
        migration_source_id = None
        if response.success:
            migration_source_id = response.migration_source_id
        heart_beat_request = heartbeat_request.HeartBeatRequest(migration_source_id=migration_source_id)
        heart_beat_response = heart_beat.HeartBeatResponse()
        hb = heart_beat.HeartBeat(heart_beat_request=heart_beat_request, heart_beat_response=heart_beat_response,
                                  agent_client=self.client)
        hb.heart_beat()
        task_metadata = heart_beat_response.get_task_metadata()
        print(task_metadata.__dict__)
        self.assertEqual(type(task_metadata), heart_beat.TaskMetadata)


if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestHeartBeat("test_heart_beat"))
    runner = unittest.TextTestRunner()
    runner.run(suite)
