from migrate_center_agent import modify
import migrate_center_agent

import unittest

class TestModify(unittest.TestCase):
    def setUp(self) -> None:
        dest_ip = "192.168.56.101"
        dest_test_user = "root"
        self.modify = modify.Modify(root_user=dest_test_user, ip=dest_ip)

    def test_get_new_uuid(self):
        new_uuid = self.modify.get_new_uuid()
        print(new_uuid)
        self.assertEqual(len(new_uuid), 36)

    def test_get_old_uuid(self):
        old_uuid = self.modify.get_old_uuid()
        print(old_uuid)
        self.assertEqual(len(old_uuid), 36)

    def test_replace_uuid(self):
        self.modify.replace_uuid()
        if self.modify.err:
            print(self.modify.err_log)
        self.assertFalse(self.modify.err)

if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestModify("test_get_new_uuid"))
    suite.addTest(TestModify("test_get_old_uuid"))
    suite.addTest(TestModify("test_replace_uuid"))
    runner = unittest.TextTestRunner()
    runner.run(suite)
