from migrate_center_agent import mount

import unittest

class TestMount(unittest.TestCase):
    def setUp(self) -> None:
        """
        Set up the Mount class
        """
        dest_ip = "192.168.56.101"
        dest_test_user = "root"
        self.mount = mount.Mount(root_user=dest_test_user, ip=dest_ip)

    def test_get_remote_disks_sizes_devices(self):
        """
        Test get the devices and sizes of the remote disk
        """
        err, err_log, sizes_devices = self.mount.get_remote_disks_sizes_devices()
        self.assertFalse(err)
        print(sizes_devices)

    def test_create_partition(self):
        """
        Test create partition.
        """
        test_device = "/dev/sdb"
        err, err_log = self.mount.create_partition(test_device)
        self.assertFalse(err)

    def test_create_file_system(self):
        """
        Test create specified file system on specified partition.
        """
        test_partition = "/dev/sdb1"
        err, err_log = self.mount.create_file_system(test_partition)
        self.assertFalse(err)

    def test_mount_partition(self):
        """
        Test mount specified partition on specified directory.
        """
        test_partition = "/dev/sdb1"
        test_mount_dir = "/mnt/sysdata"
        err, err_log = self.mount.mount_partition(test_partition, test_mount_dir)
        self.assertFalse(err)

    def test_mount(self):
        """
        Test mount multiple disks at once
        """
        self.mount.mount()
        self.assertFalse(self.mount.err)
        print(self.mount.src_to_dest)


if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestMount("test_get_remote_disks_sizes_devices"))
    suite.addTest(TestMount("test_create_partition"))
    suite.addTest(TestMount("test_create_file_system"))
    suite.addTest(TestMount("test_mount_partition"))
    suite.addTest(TestMount("test_mount"))
    runner = unittest.TextTestRunner()
    runner.run(suite)
