from migrate_center_agent.rsync import rsync

import unittest
import time
import gevent
class TestRsync(unittest.TestCase):
    def setUp(self) -> None:
        dest_ip = "192.168.56.101"
        dest_test_user = "wxh"
        src_path = "/Users/wangxuhao/Downloads/"
        dest_path = "~/rsync_test/"
        self.rsync = rsync.Rsync(src_path, dest_path, dest_ip, dest_test_user)

    def test_command(self):
        cmd = self.rsync.commands()
        print(cmd)

    def test_start_sync(self):
        self.rsync.start_sync()
        while self.rsync.return_code == None:
            gevent.sleep(1)
        gevent.sleep(1)
        self.assertEqual(self.rsync.return_code, 0)

    def test_stop_sync(self):
        self.rsync.start_sync()
        time.sleep(1)
        self.rsync.stop_sync()
        return_code = self.rsync.process.wait()
        self.assertTrue(return_code != 0)

    def test_get_speed_progress_left_time(self):
        self.rsync.start_sync()
        while self.rsync.return_code == None:
            print(self.rsync.sync_execute_info, "test")
            gevent.sleep(1)
        self.assertEqual(self.rsync.return_code, 0)

if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestRsync("test_command"))
    suite.addTest(TestRsync("test_start_sync"))
    suite.addTest(TestRsync("test_stop_sync"))
    suite.addTest(TestRsync("test_get_speed_progress_left_time"))
    runner = unittest.TextTestRunner()
    runner.run(suite)




