from migrate_center_agent import umount

import unittest

class TestUmount(unittest.TestCase):
    def setUp(self) -> None:
        dest_ip = "192.168.56.101"
        dest_test_user = "root"
        self.umount = umount.Umount(root_user=dest_test_user, ip=dest_ip)

    def test_umount_proc(self):
        err, err_log = self.umount.umount_proc()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_umount_bind(self):
        err, err_log = self.umount.umount_bind()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_umount_devpts(self):
        err, err_log = self.umount.umount_devpts()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_umount_system_disk(self):
        err, err_log = self.umount.umount_system_disk()
        if err:
            print(err_log)
        self.assertFalse(err)

    def test_umount(self):
        self.umount.umount()
        if self.umount.err:
            print(self.umount.err_log)
        self.assertFalse(self.umount.err)


if __name__ == '__main__':
    suite = unittest.TestSuite()
    suite.addTest(TestUmount("test_umount_proc"))
    suite.addTest(TestUmount("test_umount_bind"))
    suite.addTest(TestUmount("test_umount_devpts"))
    suite.addTest(TestUmount("test_umount_system_disk"))
    suite.addTest(TestUmount("test_umount"))
    runner = unittest.TextTestRunner()
    runner.run(suite)


